<script>
import { max } from "d3-array";

  import { csv } from "d3-fetch";
  import { onMount } from "svelte";
  import { empty } from "svelte/internal";
  import Scatter from "./_ex_4_scatter.svelte";

  // Load the data
  let data = null;
  onMount(async () => {
    data = await csv("/data/cars-2.csv");
    data.forEach(extractCoordinate)
  });

  $: coords = [];
  function extractCoordinate(value, index, array) {
    // console.log(value, index)
    coords[index] = [value.Horsepower, value.Acceleration];
  }

  const zip = (a, b) => a.map((k, i) => [k, b[i]]);

  $: sm1 = [];
  $: sm2 = [];
  $: globalMask = [];
  $: myRange1 = null;
  $: myRange2 = null;

  $: if (myRange1) {
    console.log("myRange1")
    if (myRange2) {  // sm1 is set and myRange2 exists => only elements in both selection
      let sm3 = zip(sm1, sm2).map(([x,y]) => x && y);
      globalMask = sm3;
      console.log(sm3, globalMask)
    } else {
      globalMask = sm1;
      console.log(sm1, globalMask)
    }
  } else {
      if (sm1 && !myRange2) {
        globalMask = globalMask.map((_) => true);
      }
  }

  $: if (myRange2) {
    console.log("myRange2")
    if (!myRange1) {  // if both are set => handled by myRange1
      globalMask = sm2;
      console.log(sm2, globalMask)
    }
  }  // else part also handled by myRange1

  // Configurations
  const s1 = {
    x: (d) => +d.Horsepower,
    y: (d) => +d.Acceleration,
    xLabel: "Horsepower",
    yLabel: "Acceleration",
  };
  const s2 = {
    x: (d) => +d.Displacement,
    y: (d) => +d.Miles_per_Gallon,
    xLabel: "Displacement",
    yLabel: "Miles per Gallon",
  };
</script>

{#if !data}
  <p>Loading the data, please wait...</p>
{:else}
  <Scatter {data} {...s1} bind:selectionMask={sm1} bind:myRange={myRange1} bind:globalMask={globalMask}/>
  <Scatter {data} {...s2} bind:selectionMask={sm2} bind:myRange={myRange2} bind:globalMask={globalMask}/>
{/if}
<br>

